//+------------------------------------------------------------------+
//|                                        Top Indicators Collection |
//|                                 https://www.forex-indicators.org |
//+------------------------------------------------------------------+

#property copyright   "www.forex-indicators.org"
#property link        "https://www.forex-indicators.org"
#property description "If this indicator does not work, please contact us at: bestindicators@proton.me"

#property indicator_chart_window
#property indicator_buffers 3
#property indicator_plots   1
#property indicator_color1  clrRed, clrYellow, clrLime, clrWhite, clrMagenta
#property indicator_type1   DRAW_COLOR_HISTOGRAM2
#property indicator_width1  2

input int NumberOfBars = 500; // Number of Bars ("0" will display all bars)
input int MAPeriod = 100;
input int LookBack = 20;

double HistogramLow[];
double HistogramHigh[];
double HistogramColor[];

int LastCounted = 0;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
void OnInit()
{
	IndicatorSetString(INDICATOR_SHORTNAME, "BVCB(" + IntegerToString(MAPeriod) + ", " + IntegerToString(LookBack) + ")");
	
	SetIndexBuffer(0, HistogramLow, INDICATOR_DATA);
	SetIndexBuffer(1, HistogramHigh, INDICATOR_DATA);
	SetIndexBuffer(2, HistogramColor, INDICATOR_COLOR_INDEX);
	
	
}

//+------------------------------------------------------------------+
//| Drawing Better Volume on chart                                   |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &Time[],
                const double &open[],
                const double &High[],
                const double &Low[],
                const double &Close[],
                const long &Tickvolume[],
                const long &volume[],
                const int &spread[])
{
   double Range, Value2, Value3, HiValue2, HiValue3, LoValue3, tempv2, tempv3;
   int limit, n ,i;
   long VolLowest;

   int minbars = MathMax(20, MathMax(MAPeriod, LookBack));

   limit = LastCounted - 1;
   if (NumberOfBars > 0) 
      if (rates_total - limit > NumberOfBars) limit = rates_total - NumberOfBars;

   if (limit < minbars) limit = minbars;
      
   for (i = rates_total - 1; i >= limit; i--)   
   {
      HistogramLow[i] = 0;
      HistogramHigh[i] = 0;
      HistogramColor[i] = -1;
      
      Value2 = 0; Value3 = 0; HiValue2 = 0; HiValue3 = 0; LoValue3 = DBL_MAX; tempv2 = 0; tempv3 = 0;
      
      VolLowest = Tickvolume[ArrayMinimum(Tickvolume, i - 19, 20)];
            
      Range = High[i] - Low[i];
      Value2 = Tickvolume[i] * Range;
      
      if (Range != 0) Value3 = Tickvolume[i] / Range;
         
      for (n = i; n > i - LookBack; n--)
      {
         tempv2 = Tickvolume[n] * (High[n] - Low[n]); 
         if (tempv2 > HiValue2) HiValue2 = tempv2;
              
         if (Tickvolume[n] * (High[n] - Low[n]) != 0)
         {           
            tempv3 = Tickvolume[n] / (High[n] - Low[n]);
            if (tempv3 > HiValue3) HiValue3 = tempv3; 
            if (tempv3 < LoValue3) LoValue3 = tempv3;
         } 
      }
                                   
      if ((Value2 == HiValue2) && (Close[i] > (High[i] + Low[i]) / 2))
         HistogramColor[i] = 0; // Red
        
      if ((Tickvolume[i] == VolLowest) && (Value3 != HiValue3))
         HistogramColor[i] = 1; // Yellow

      if (Value3 == HiValue3)
         HistogramColor[i] = 2; // Lime
      
      if ((Value2 == HiValue2) && (Value3 == HiValue3))
         HistogramColor[i] = 4; // Magenta
      
      if ((Value2 == HiValue2)  && (Close[i] <= (High[i] + Low[i]) / 2))
         HistogramColor[i] = 3; // White
         
      // If color index was filled with actual color numbe, need to draw histogram bar. Otherwise, re-assign 0 value.
      if (HistogramColor[i] != -1)
      {
         HistogramLow[i] = Low[i];
         HistogramHigh[i] = High[i];
      }
      else HistogramColor[i] = 0;
   }
      
   LastCounted = rates_total;
   return(rates_total);
}
//+------------------------------------------------------------------+
         